#pragma once
#include <vector>
#include <map>
#include <iostream>

namespace RLDoom {
	namespace FileSystem {
		typedef enum {
			INVALID, IWAD, PWAD
		} WADType;
		struct Lump {
			std::string name, data;
		};

		class WAD {
			std::vector<Lump> lumps;
		public:
			WADType wadType;
			int lumpCount;
			WAD();
			WAD(std::string path);
			std::vector<Lump> getLumps() {
				return lumps;
			}
			~WAD();
		};

		class FileSystem {
			std::map<std::string, WAD*> wads;
		public:
			FileSystem();
			WAD* getWAD(std::string wad);
			std::map<std::string, WAD*> getWADs();
			~FileSystem();
		};
	}
}